; Possible read filename dx:ds, length cx, data from es:bx

Pos_Read_File:	jz PRF_Exit		; Don't, exit

	; Definately read it

F_Read_File:	sti			; EI

		mov cs:WF_Len,cx	; Save the length

		mov cs:WF_Off,bx	; Start of data

		mov ax,es		; Save the seg
		mov cs:WF_Seg,ax	;

		mov cx,00h		; File attribute

		mov al,0		; Read only

		mov ah,OpenFile		; Call dos
		int dos			;

		jc PRF_Exit		; Can't open file

		mov cs:TempHandle,ax	; Save the handle

		; Rewind to start

		mov cx,0		; Rewind file
		mov dx,0		;

		mov bx,ax		; Handle

		mov al,0		;

		mov ah,MovePointer	;
		int dos			;

		; Read the file

		mov ax,cs:WF_Seg	; Segment
		mov ds,ax		;

		mov bx,cs:WF_Off	; Offset

		mov cx,cs:WF_Len	; Length

		call Read_Block		; Write it

		; Close the file

		push ax			; Save error code

		mov bx,cs:TempHandle	; Close it
		mov ah,CloseFile	;
		int dos			;

		pop ax			;

		; Done

PRF_Exit:	retf			; Done

; Write filename dx:ds, length cx, data from es:bx

F_Write_File:
Write_File:	sti			; EI

		mov cs:WF_Len,cx	; Save the length

		mov cs:WF_Off,bx	; Start of data

		mov ax,es		; Save the seg
		mov cs:WF_Seg,ax	;

		mov cx,00h		; File attribute

		mov ah,CreateFile	; Call dos
		int dos			;

		jc WF_Fail		; Can't create file

		mov cs:TempHandle,ax	; Save the handle

		; Write the keys

		mov ax,cs:WF_Seg	; Segment
		mov ds,ax		;

		mov bx,cs:WF_Off	; Offset

		mov cx,cs:WF_Len	; Length

		call Save_Block		; Write it

		; Close the file

		push ax			; Save error code

		mov bx,cs:TempHandle	; Close it
		mov ah,CloseFile	;
		int dos			;

		pop ax			;

		; Done

WF_Fail:	retf			; Done

; Write block ds:bx for length cx

Save_Block:	push ax			; Save reg
		push dx			;

		mov dx,bx		; Get ptr

		mov bx,cs:TempHandle	; Get file handle

		mov ah,WriteToFile	; Write it
		int dos			;
		jc SB_Fail		; Fail

		cmp ax,cx		; Save full length ?
		jz SB_OK		; Yes, skip

		stc			; Assert fail

SB_Fail:	pop dx			; Restore
		pop ax			; dummy

		mov al,64		; "Disc full"

		ret			;

SB_OK:		pop dx			; Restore
		pop ax			;

		ret			;

; Read block ds:bx for length cx

Read_Block:	push ax			; Save reg
		push dx			;

		mov dx,bx		; Get ptr

		mov bx,cs:TempHandle	; Get file handle

		mov ah,ReadFromFile	; Read it
		int dos			;
		jc SB_Fail		; Fail

		cmp ax,cx		; Save full length ?
		jz SB_OK		; Yes, skip

		stc			; Assert fail

		jmp SB_Fail		; Fail

; Vars

WF_Len		dw ?			; Length
WF_Seg		dw ?			; Segment
WF_Off		dw ?			; Offset

TempHandle	dw ?			; Handle
