; This is the front-end for the Game Zone. (c) Design-Design

HS_Y		equ 37			; Start of HS
HS_X		equ 30			; LHS
HS_RHS		equ 575			; RHS
HS_dY		equ 17			; Step between them

Time_Out	equ 8 * 70		; This long

Play_Games:	mov cs:Stk,sp		; Save the stack

		call Hide_Disp		; Redraw

		call CLS		; Clear it

		call Show_Logo		; Show it (Full)

		mov si,o sWaiting	; Waiting
		call Print_Str		; Show it

		call Show_Disp		; Show it

		; Right, do we want to read any files

		call Read_Files		; Read them

		; Show the main titles

Main_Menu:	mov sp,cs:Stk		; Restore the stack

		call Hide_Disp		; Redraw

		call CLS		; Clear it

		call Show_Logo		; Show it

		mov si,o sName		; Title
		call Print_Str		; Show it

		call Show_Disp		; Show it

		; Wait for a key

		mov cx,Time_Out		; Wait this long

		; Scan the keys

		mov si,o mnu_Main	; Data

	; Wait for a key

Wait_Menu_Key:	push si			; Save
		call Drive_Menu		; Any keys ?
		pop si			; Restore

		jc MML_1		; No, skip

		; We have a new driver, jump to it

		jmp bx			; Off we go

	; Wait for a frame

MML_1:		push si			; Save
		call Next_Frame		; Pause a bit
		pop si			; Restore
		
		jmp s Wait_Menu_Key	; Again

	; Play a game

Play_A_Game:	mov al,0		; Page 0
		call Set_VDU_Page	;
		call Set_DRAW_Page	;

		call far ptr Play_Game	; Play it

		push ax			; Save the score

		call Set_640_350	; Set display mode

		mov al,0		; Page 0
		call Set_VDU_Page	;
		call Set_DRAW_Page	;

		pop ax			; Restore

		jmp Leave_Game		; Leave it

; Escape entry

Leave_Main:	mov sp,cs:Stk		; Recover

		; Now, have we been here a while ?

		test b cs:Long_Time_F,-1; Have we been running a fair time ?
		je LM_X			; No, exit

		; Yes, show the shareware messages

		mov si,o Share_Text	;

		; Fall into

Share_Lp:	mov ax,TEXT		; End ?
		mov ds,ax		;

		mov al,ds:[si]		; Next char
		cmp al,"@"		; EOF ?
		je LM_X1		; Yes, exit

		call CLS		; Clear the screen

		call Print_Screen	; Show a screen-full

		push si			; Save the ptr

Share_Lp1:	mov si,o mnu_Share	; Data
		call Drive_Menu		; Any keys ?
		jc Share_Lp1		; No, skip

		pop si			; Restore

		; Return ?

		cmp bl,1		; Esc ?
		je Main_Menu		; Yes, skip

		; Now, loop

		jmp s Share_Lp		; Loop

	; Should we show the extra share page ?

LM_X1:		test b cs:Order_F,-1	; Seen the order pages ?
		jz LM_X			; No, exit

		; Yes, clear the flag so 'no' next time

		mov b cs:Order_F,0	; Clear it

		; Show the rest

		inc si			; Skip "@"
		jmp s Share_Lp		; Loop

	; Exit

LM_X:		ret			; Done

; Write the key crap out

Main_Write_File equ Main_Menu

;		include wrtfile.inc	; The file crap

; Manage the display

Hide_Disp:	mov al,0		; Default to page 0

		test b cs:fForce_Quick,1; Quick ?
		jnz HD_1		; Yes, skip

		mov al,cs:Front_Screen	; Draw on the other page
		not al			; Flip it
		and al,1		; 0/1
HD_1:		mov cs:Front_Screen,al	;

		jmp Set_DRAW_Page	; Set it

; Show the new screen

Show_Disp:	mov al,cs:Front_Screen	; The drawn page
		jmp Set_VDU_Page	; Show it

; The game options

Main_O:		call Hide_Disp		; Flip pages

		call CLS		; Clear it

		call Show_Logo		; Show the logo

		mov si,o sTitle_2	; Title
		call Print_Str		; Show it

		mov si,o sOptions	; Options
		call Print_Str		; Show it

		call Show_Options	; Show the options

		; Now, swap the display

		call Show_Disp		; Show it

		; Wait for a key

		mov cx,Time_Out*3	; Wait this long

		; Scan the keys

		mov si,o mnu_Options	; Data
		jmp Wait_Menu_Key	; Wait for it

; Show the current options

Show_Options:	mov si,o sNoise_ON	; Show noises are on

		test b cs:Noise_F,-1	; On ?
		jne SO_1		; Yes, skip

		mov si,o sNoise_OFF	; Off

SO_1:		call Print_Str		; Show it

		; Difficulty level

		mov al,cs:Difficulty	; Level
		and al,03h		; 0 .. 3

		mov si,o sDiff_0	; 0
		jz SO_2			; Yes

		mov si,o sDiff_1	; 1
		dec al			;
		jz SO_2			; Yes

		mov si,o sDiff_2	; 2
		dec al			;
		jz SO_2			; Yes

		mov si,o sDiff_3	; 3

SO_2:		call Print_Str		; Show it

		; Language

		test b cs:Lang_Vis_F,-1	; Visible ?
		jz SO_X			; No, exit

		; Show the name

		mov si,o sLang		; Title
		call Print_Str		;

		mov al,cs:Language	; Level
		and al,03h		; 0 .. 3

		mov si,o sLang_0	; 0
		jz SO_3			; Yes

		mov si,o sLang_1	; 1
		dec al			;
		jz SO_3			; Yes

		mov si,o sLang_2	; 2
		dec al			;
		jz SO_3			; Yes

		mov si,o sLang_3	; 3

SO_3:		jmp Print_Str		; Show it

SO_X:		ret			; Exit

; Change the noise option

Option_Noise:	not b cs:Noise_F	; Flip it
		jmp Main_O		; Show the change

; Change the difficulty option

Option_Diff:	inc b cs:Difficulty	; Step it
		jmp Main_O		; Show the change

; Change the language option

Option_Lang:	mov b cs:Lang_Vis_F,1	; We can see it

		inc b cs:Language	; Step it
		and b cs:Language,03h	; 0 .. 3

		jmp Main_O		; Show the change

; Extra options, text first

Extra_Options:	mov si,o Extra_Text	; Extras

		; Show it

		call CLS		; Clear the screen

		call Print_Screen	; Show a screen-full

		; Show the option

SEO_Show:	mov b cs:Dec_Col,00Bh	; Set the colour

		call Show_Ext_Opt	; Show it

		; Now, wait for a key, etc

		mov si,o mnu_Extra_Opts	; Data
		jmp Wait_Menu_Key	; Wait for it

; Step the ptr up

SEO_Up:		mov al,-1		; Dec it
		jmp s SEO_Ptr		; Skip

SEO_Down:	mov al,+1		; Inc it

SEO_Ptr:	push ax			; Save

		; Clear the option display

		mov b cs:Dec_Col,0	; Set the colour

		call Show_Ext_Opt	; Show it

		pop ax			; Restore

		add al,cs:nOption	; Step it
		call Get_pOption	; Point at it

		cmp bx,o Option_B_End	; In range ?
		jnc SEO_Show		; No, loop

		mov cs:nOption,al	; Save new ptr

		jmp s SEO_Show		; Loop

; Step the value up

SEO_Inc:	mov al,1		; Inc it
		jmp s SEO_Val		; Skip

SEO_Dec:	mov al,-1		; Dec it

SEO_Val:	push ax			; Save

		; Clear the option display

		mov b cs:Dec_Col,0	; Set the colour

		call Show_Ext_Opt	; Show it

		; Point at the value

		mov al,cs:nOption	; Get the address
		call Get_pOption	;

		pop ax			; Restore

		add al,cs:[bx]		; Step it

		cmp al,cs:1[bx]		; >min ?
		jc SEO_Show		;

		cmp al,cs:2[bx]		; <=max ?
		ja SEO_Show		;

		; Store new value

		mov cs:[bx],al		; Store it

		jmp s SEO_Show		; Loop

; Show the extra option

Show_Ext_Opt:	mov cx,110		; New X
		mov dx,307		; Y

		mov al,cs:nOption	; Address
		mov ah,0		;

		call WriteDec16		; Show the number

		; Read the option

		mov al,cs:nOption	; Point at it
		call Get_pOption	; Point at it

		mov al,cs:[bx]		; Read it
		mov ah,0		;

		mov cx,290		; New X

		call WriteDec16		; Show the number

		; Show the name ?

		mov al,cs:optShowName	; Get the flag
		cmp al,42		; The magic number
		jne SEO_X		; No, exit

		; Show it

		mov cx,600		; X

		mov ah,cs:Dec_Col	; Colour

		mov al,cs:3[bx]		; First char
		call Print_Char		;

		mov al,cs:4[bx]		; Next char
		jmp Print_Char		;
	
; Given al = option number, return bx = ptr to option

Get_pOption:	mov ah,0		; 16-bit

		mov bx,ax		; Into ptr
		add bx,bx		; * 5
		add bx,bx		;
		add bx,ax		;

		add bx,o Option_Bytes	; Point at them

SEO_X:		ret			; Done

; Options menu

mnu_Options	db cEsc			; ESC
		dw Main_Menu		;

		db "N"			; Noises
		dw Option_Noise		;

		db "D"			; Difficulty
		dw Option_Diff		;

		db "L"			; Language
		dw Option_Lang		;

		db "E"			; Extras
		dw Extra_Options	;

		db " "			; Play
		dw Play_A_Game		;

		db 0			; Done

; Extra options menu

mnu_Extra_Opts	db cEsc			; ESC
		dw Main_O		;

		db cUp			; Up
		dw SEO_Up		;

		db cDown		; Down
		dw SEO_Down		;

		db cLeft		; Dec
		dw SEO_Dec		;

		db cRight		; Inc
		dw SEO_Inc		;

		db 0			; Done

; The information pages

Main_I:		call Hide_Disp		; Drawing

		call CLS		; Clear it

		call Show_Logo		; Show it

		mov si,o sTitle_2	; Title
		call Print_Str		; Show it

		mov si,o sInfo		; Rest of page
		call Print_Str		; Show it

		call Show_Disp		; Show it

		; Wait for a key

		mov cx,Time_Out*3	; Wait this long

		; Scan the keys

Main_Info_Lp:	mov si,o mnu_Info	; Data
		jmp Wait_Menu_Key	; Wait for it

; Information - essentials

Info_Ess:	mov si,o Ess_Text	; Point at the text
		jmp s InD_Lp		; Show it

; Information - Story time

Info_Dave:	mov si,o Story_Text	;
		jmp s InD_Lp		;

; Information - Playing the game

Info_Play:	mov si,o Play_Text	;
		jmp s InD_Lp		;

; Information - Various

Info_Var:	mov si,o Var_Text	;
		jmp s InD_Lp		;

; Information - Ordering

Info_Order:	mov si,o Ord_Text	;

		; Flag that we saw the order pages . . 

		mov b cs:Order_F,1	; Assert seen the order pages

		; Fall into

InD_Lp:		call CLS		; Clear the screen

		call Print_Screen	; Show a screen-full

		cmp al,01Ah		; EOF ?
		je InD_Exit		; Yes, exit

		; Get an escape or a space

		push si			; Save the ptr

InD_Lp1:	mov si,o mnu_Dave	; Data
		call Drive_Menu		; Any keys ?
		jc InD_Lp1		; No, skip

		pop si			; Restore

		; Esc ?

		cmp bl,1		; Esc ?
		je vMain_I		; Yes, skip

		; Now, loop

		jmp s InD_Lp		; Loop

; Vectors

InD_Exit:
vMain_I:	jmp Main_I		; Info

	; Routines for tetris

Far_Next_Frame:	call Next_Frame		; Wait a frame.
		retf			;

Main_K:		call Hide_Disp		; Hide it

		call CLS		; Clear the foreground

		mov ax,o UDK_List1	; First keys
		mov cs:pUDK_List,ax	;

		mov si,o sKeys		; Keys
		call Print_Str		; Show it

		mov si,o sKeys1		; Keys
		call Print_Str		; Show it

		call Show_Disp		; Show it

		call MKK_X		; Drive these keys

		; Second page

		call Hide_Disp		; Hide it

		call CLS		; Clear the foreground

		mov ax,o UDK_List2	; First keys
		mov cs:pUDK_List,ax	;

		mov si,o sKeys		; Keys
		call Print_Str		; Show it

		mov si,o sKeys2		; Keys
		call Print_Str		; Show it

		call Show_Disp		; Show it

		call MKK_X		; Drive these keys

		; Done

		jmp Main_Menu		; Exit

; Show the data for the UDK's

MKK_X:		mov di,cs:pUDK_List	; UDK data

MK_Lp:		push di			; Save

		mov cx,cs:3[di]		; X
		mov dx,cs:5[di]		; Y
		mov di,cs:1[di]		; Point at the list

		; Show this UDK

		mov ah,11		; Cyan

		call Show_UDK_List	; Show it

		pop di			; Restore

		lea di,7[di]		; Skip this one

		cmp b cs:[di],0		; End ?
		jnz MK_Lp		; No, loop

		; Done, wait for a key

MK_Wait_Lp:	call Get_Key		; Giz a key

		; Is this an ESC ?

		cmp al,cEsc		; Esc ?
		je MK_Exit		; Yes, back up

		; Is this a key selection ?

		mov di,cs:pUDK_List	; UDK data

MK_Lp2:		mov ah,cs:[di]		; The key

		cmp ah,0		; End of keys ?
		je MK_Wait_Lp		; Yes, ignore this key

		; Is it this key ?

		cmp al,ah		; This key ?
		je MK_Define		; Yes, define it

		; No, skip this key

		lea di,7[di]		; Skip this key

		jmp s MK_Lp2		; Loop

	; Exit the key definition

MK_Exit:	ret			; Done

	; Now, edit this key

MK_Define:	mov al,cs:fForce_AT	; Force flag
		call Link_Kbd		; Start the game key scanning

		; Point at the data

		mov cx,cs:3[di]		; X
		mov dx,cs:5[di]		; Y
		mov di,cs:1[di]		; Point at the list
		mov si,di		; Point at the list

		; Clear this UDK

		mov ah,0		; Black

MKD_Show:	call Show_UDK_List	; Show it

		; Clear it's data/terminate it

		mov b cs:[si],0		; Kill the list of keys

		; Do we have any room for another key ?

		lea bx,UDK_nKeys[di]	; Point at the end
		cmp bx,si		; There yet ?
		je MKD_X		; Yes, exit the editor

		; Now, get a Key-number

MK_Key_Lp:	call MK_ScanCode	; Giz a scan code

		; Now is this ESC (01) ?

		cmp al,01h		; ESC ?
		je MKD_X		; Yes, skip

		; Now add this key-code

		call MK_AddCode		; Add it to the list

		; Show the key-list

		mov ah,0Fh		; In white
		
		jmp s MKD_Show		; Loop

	; Exit

MKD_X:		call Unlink_Kbd		; Unlink the keyboard

		; Done, exit

		jmp s MKK_X		; Loop

	; Add this key-code to the list

MK_AddCode:	lea bx,UDK_nKeys[di]	; End of the list

		cmp si,bx		; End of space ?
		je MKAC_X		; Yes, skip

		mov cs:[si],al		; Store this code
		inc si			; Step
		mov b cs:[si],0		; End the list

MKAC_X:		ret			; Done

	; Get a scan-code

MK_ScanCode:	push di			; Save the ptr
		push dx			;

		mov dx,di		; Point at the key-list

MKSC_Lp:	mov al,00h		; Key-code

		mov bx,o Key_Matrix	; Point at the key-flags

MKSC_Lp2:	test b cs:[bx],1	; Pressed ?
		je MKSC_Nxt		; No, skip

		; This is pressed, is it in the list ?

		mov di,dx		; Point at the list

MKSC_Cmp_Lp:	mov ah,cs:[di]		; Next key
		inc di			; Skip

		cmp ah,0		; End ?
		je MKSC_X		; Yes, report this code

		cmp al,ah		; Is this key included ?
		je MKSC_Nxt		; Yes, ignore it

		jmp s MKSC_Cmp_Lp	; Try the next

	; Exit with this code

MKSC_X:		pop dx			; Restore
		pop di			;

		ret			; Done

	; Find the next key pressed

MKSC_Nxt:	inc bx			; Step the ptr

		inc al			; Step the key-code

		cmp al,80h		; 00 .. 7F
		jne MKSC_Lp2		; Yes, loop

		; Try again

		jmp s MKSC_Lp		; Loop

; Given a ptr in di, colour in ah, x in cx and y in dx show a keys list

Show_UDK_List:	push di			; Save
		push dx			;
		push cx			;

		; Point at the seg

		mov bx,DATA		; Setup the segment
		mov ds,bx		;

		; Show the list

SUL_Lp:		mov b cs:Curr_CS,1	; Medium size chars

		mov al,cs:[di]		; Next key
		inc di			;

		cmp al,0		; End ?
		jz SUL_X		; Yes, skip

		mov bx,o Key_Chars	; Find the string
		add bl,al		; Index into the table
		adc bh,0		;

		; Get the token for this key

		mov al,[bx]		; Get the token

		cmp al,0		; Valid ?
		jz SUL_Lp		; No, skip

		cmp al,080h		; = token ?
		jae SUL_Str		; Yes, skip

		; It is a char, show it

		call SUL_Print		; Show the char

SUL_Sep:	mov b cs:Curr_CS,1	; Medium space

		mov al," "		; Space
		call SUL_Print		;

		; Now, next

		jmp s SUL_Lp		; Loop

	; It is a string, get it

SUL_Str:	mov b cs:Curr_CS,2	; Small chars

		mov bx,o Key_Strings	; Find the string

		sub al,80h		; 0 .. n
		je SULS_Lp2		; 0, got it

		; Skip to a 00

SULS_Lp:	inc bx			; Skip a char

		cmp b -1[bx],0		; 00 ?
		jne SULS_Lp		; No, skip chars

		; Is this the string

		dec al			; One less
		jnz SULS_Lp		; No, loop

		; Show this string

SULS_Lp2:	mov al,[bx]		; Get it
		inc bx			;

		cmp al,0		; End ?
		jz SUL_Sep		; Yes, done

		; Show this char

		call SUL_Print		; Show the char

		jmp s SULS_Lp2		; Loop

	; Exit

SUL_X:		pop cx			; Restore
		pop dx			;
		pop di			;

		ret			; Done

; Print the char and wrap-round

SUL_Print:	call Print_Char		; Show it

		; Is the X in range ?

		cmp cx,620		; Clip to this
		jb SULP_X		; Yes, skip

		; Clip it

		add dx,20		; Move down

		mov cx,140		; Clip the X

		; Done

SULP_X:		ret			; Done

; Highscores

Main_H:		call Hide_Disp		; Drawing

		call Show_HighScore	; Show them

		; Show the controls

		mov si,o sEsc_Or_Space	; "Esc or Space"
		call Print_Str		; Show it

		call Show_Disp		; Show it

		; Wait for a key

HS_Wait:	mov cx,Time_Out		; Wait this long

		; Scan the keys

		mov si,o mnu_High	; Data

		jmp Wait_Menu_Key	; Scan the keys

; Show the high scores

Show_HighScore:	push ds			; Save
		push di			;
		push si			;

		push dx			; Save

		; Setup the display

		call CLS		; Clear the screen

		; Show a title

		mov si,o sTitle		; Title
		call Print_Str		; Show it

		; Show the score

		mov ax,DATA		; Segment
		mov ds,ax		;

		; Show a high-score string

		mov di,o High_Scores	; Point at the high-scores

		; Set CS 1

		mov b cs:Curr_CS,2	; Set the small CS

		; Setup the Y

		mov dx,HS_Y		; Y

		; Show the high scores

SHS_Lp:		mov si,di		; Point at the next entry

		; Show the entry number

		mov ah,00Fh		; White

		mov cx,0		; X

		; Show the entry number

		mov al,[si]		; Get the character
		inc si			;

		call Print_Char		; Show the character

		; Show the entry

		mov cx,HS_X		; New X

		mov ah,0Eh		; Yellow

		; Show the string

SHS_Lp2:	mov al,[si]		; Get the next char
		inc si			; Skip

		cmp al,0		; End ?
		je SHS_1		; Yes, exit

		cmp al," "		; Ctrl ?
		jae SHS_2		; No, skip

		mov ah,al		; Just use it as a colour

		jmp s SHS_Lp2		; Loop

	; Show this char

SHS_2:		call Print_Char		; Show it

		jmp s SHS_Lp2		; Loop

	; Now, get the score

SHS_1:		mov ax,[si]		; Get the score

		mov cx,HS_RHS		; New X

		mov b cs:Dec_Col,00Bh	; Set the colour

		; Show the score

		call WriteDec16		; Show the number

		; Next line

		lea di,112[di]		; Skip the entry

		add dx,HS_dY		; Move Y down

		; Another one ?

		test b [di],-1		; End ?
		jnz SHS_Lp		; No, loop

		; Done, exit

		pop dx			; Restore

		pop si			;
		pop di			;
		pop ds			;

		ret			; Done

; Get here when leaving the game

Leave_Game:	mov cs:Score,ax		; Save the score

		; Show the score

		call CLS		; Clear the display

		; Show the score display

		mov si,o sScore		; Score
		call Print_Str		; Show it

		; Set the colour

		mov b cs:Dec_Col,0Bh	; Cyan

		; Show the score

		mov ax,cs:Score		; Get the score
		call WriteDec16		; Show it

		; Now, do we have to enter this in the high-score table ?

		; Was this a cheat ?

;		test b cs:Cheat_F,-1	; Cheating ?
;		jnz LG_Replay		; Yes, exit

		; Was this the trainer ?

		test b cs:Difficulty,03h; Trainer ?
		jz LG_Replay		; Yes, exit

		; Pause

		call Get_Key		; Giz a key

		mov ax,DATA		; Setup the seg
		mov ds,ax		;

		mov di,o High_Scores	; Point at the first entry

		; We must find the entry's Y

		mov dl,HS_Y		; The start line

		; Find the score for this entry

FHS_Lp:		mov si,di		; Find the score

		; Skip this entry

FHS_Lp2:	mov al,[si]		; Get it
		inc si			;

		cmp al,0		; End ?
		jnz FHS_Lp2		; No, skip

		; si points at the score

		mov ax,[si]		; Are we higher ?
		cmp ax,cs:Score		;
		jb FHS_Insert		; Yes, insert here

		; Find the next entry

		add dx,HS_dY		; Move down

		lea di,112[di]		; Skip this entry

		; Loop

		cmp b [di],0		; End ?
		jnz FHS_Lp		; No, loop

		; Done, exit

vMain_H:	jmp Main_H		; Exit

	; We are replaying, pause

LG_Replay:	mov cx,50		; Wait a bit

LGR_Lp:		call Next_Frame		;
		loop LGR_Lp		;

		jmp s vMain_H		; Exit

	; Insert in front of this line

FHS_Insert:	mov bx,di		; Point at the entry

		; Find the end of the high-scores

FHS_I_Lp:	lea di,112[di]		; Move down

		cmp b [di],0		; End ?
		jne FHS_I_Lp		; No, loop

		; Right, move down one entry

FHS_I_C_Lp:	dec di			; Move back

		mov cx,111		; Copy all but the number

FHS_I_C_Lp2:	mov al,-112[di]		; Copy the entry
		mov [di],al		;

		dec di			; back one

		loop FHS_I_C_Lp2	; Loop

		; This one

		cmp bx,di		; This one ?
		jne FHS_I_C_Lp		; No, move it

		; We have moved down, clear this line

		lea si,1[di]		; Point at the high-score entry

		mov b [si],0		; Kill this entry

		mov ax,cs:Score		; Get the score
		mov 1[si],ax		; Set it

		; Show the high-score table

		call Show_HighScore	; Show them

		; Now edit the entry

		mov di,o Line_Buffer	; We must store the X for deletes

		mov w [di],0		; X = 0

		add di,2		; Skip beginning

		; Get the entry

		mov cx,HS_X		; X of the entry

		mov ah,0Eh		; Yellow

		push si			; Save a ptr to the entry

		; Edit it

FHSI_Lp:	call Get_Key_Cur	; Pause		

		cmp al,cCret		; End ?
		je FHSI_X		; Yes, skip

		cmp al,cDel		; Delete ?
		je FHSI_Del		; Yes, skip

		cmp al," "		; Valid ?
		jb FHSI_Lp		; No, ignore

		; Can we add this char ?

		cmp cx,HS_RHS-12	; Any room ?
		jae FHSI_Lp		; No, ignore it

		; Save the X

		mov [di],cx		; Save the X
		add di,2		; Skip

		; Add it to the string

		mov [si],al		; Add the char
		inc si			;

		mov b [si],0		; EOL

		mov bx,cs:Score		; Add the score
		mov 1[si],bx		;

		; Show the char

		call Print_Char		; Show it

		; Now, next

		jmp s FHSI_Lp		; Loop

	; Delete

FHSI_Del:	mov bx,-2[di]		; Get the previous X
		cmp bx,0		; SOL ?
		je FHSI_Lp		; Yes, skip

		; We can move back

		push ax			; Save the colour

		; Delete it

		mov cx,bx		; Get the old X

		mov al,-1[si]		; The character
		mov ah,0		; Colour = black

		; Erase it

		push cx			; Save the X

		call Print_Char		; Erase it

		pop cx			; Restore the X

		; In the line / buffer

		sub di,2		; Back in the buffer
		dec si			; Back in the line

		mov b [si],0		; Kill it

		mov ax,cs:Score		; Score
		mov 1[si],ax		;

		; Done, loop

		pop ax			; Restore

		jmp s FHSI_Lp		; Loop

	; Exit

FHSI_X:		pop si			; Point at the highscore entry

		mov di,o Search_Strs	; Look for these

		; Is it blank ?

		test b [si],-1		; Blank ?
		je FHS_Blank		; Yes, skip

		; See if this is a defined string ?

FHS_S_Lp:	push si			; Save
		push di			;

		call FHS_Compare	; Same ?

		pop di			;
		pop si			; Restore

		je FHS_S_Found		; This one, skip

		; No, check the next

		call FHS_Skip		; Skip the compare
		call FHS_Skip		; Skip the replace

		; Another ?

		test b [di],-1		; End ?
		jne FHS_S_Lp		; No, loop

		; Not found, leave it

		; Show the controls

		mov si,o sEsc_Or_Space	; "Esc or Space"
		call Print_Str		; Show it

		jmp HS_Wait		; Get a key

	; Blank line, put "Someone" up

FHS_Blank:	call Read_Clock		; Get the time

		mov di,o sSomeone	; Point at it

;	mov di,o Clock_Buff	; Use the time, instead

		jmp s FHSS_Rep		;

	; Found the search string, replace the entry

FHS_S_Found:	call FHS_Skip		; Avoid the search string

		; Change the colour

		mov b [si],0Fh		; White
		inc si			;

		; Replace the entry with this

FHSS_Rep:	mov al,[di]		; Get a byte

		cmp al,0FFh		; Cheat mode ?
		jne FHSS_R1		; Yes, exit

		; Flag the cheat

		; Do whatever here . . . .

		; Next

FHSS_R1:	mov [si],al		; Store it

		inc di			; Skip
		inc si			;

		cmp al,0		; End ?
		jne FHSS_Rep		; No, loop

		; Add the score

		mov ax,cs:Score		; Score
		mov [si],ax		; Add it

		; End, show it

		jmp Main_H		; Show the replacement

; Compare a string

FHS_Compare:	mov ah,[di]		; Match char
		inc di			;

		cmp ah,0		; End ?
		je FHSC_X		; Yes, skip

		mov al,[si]		; Next char
		inc si			;

		call Make_Upper		; to upper-case

		cmp al,ah		; Same ?
		je FHS_Compare		; Yes, loop

		; Different, exit

FHSC_X:		ret			; Z / NZ

; Skip to the next string

FHSS_1:		inc di			; Skip 1

FHS_Skip:	test b [di],-1		; 0 ?
		jne FHSS_1		; Yes, skip

		inc di			; Skip it
		ret			; Done

; Right, write the keys

Write_Files:	test b cs:fWriteBack,-1	; Writeback ?
		jz WF_Dont		; No, exit

		mov dx,o sKey_File	; Filename
		push cs			;
		pop ds			;

		mov bx,o Key_Left	; First key
		mov cx,o Key_Esc-Key_Left ; Length

		push cs			; Data seg
		pop es			;

		call far ptr Write_File	; Write it

		; Right, write the highscores

		mov dx,o sHigh_File	; Filename
		push cs			;
		pop ds			;

		mov bx,o High_Scores			; First key
		mov cx,o High_Scores_E-High_Scores	; Length

		mov ax,DATA		; Data seg
		mov es,ax		;

		call far ptr Write_File	; Write it

		; Right, write the options

		mov dx,o sOpt_File	; Filename
		push cs			;
		pop ds			;

		mov bx,o Option_Bytes		  ; First key
		mov cx,o All_Opt_End-Option_Bytes ; Length

		push cs			; Use cs
		pop es			;

		call far ptr Write_File	; Write it

WF_Dont:	ret			; Done

; Right, read the keys

Read_Files:	mov dx,o sKey_File	; Filename
		push cs			;
		pop ds			;

		mov bx,o Key_Left	; First key
		mov cx,o Key_Esc-Key_Left ; Length

		push cs			; Data seg
		pop es			;

		test b cs:fLoadKeys,-1	;
		call far ptr Pos_Read_File ; Read it

		; Right, read the highscores

		mov dx,o sHigh_File	; Filename
		push cs			;
		pop ds			;

		mov bx,o High_Scores			; First key
		mov cx,o High_Scores_E-High_Scores	; Length

		mov ax,DATA		; Data seg
		mov es,ax		;

		test b cs:fLoadHigh,-1	  ;
		call far ptr Pos_Read_File; Read it

		; Right, write the options

		mov dx,o sOpt_File	; Filename
		push cs			;
		pop ds			;

		mov bx,o Option_Bytes		  ; First key
		mov cx,o All_Opt_End-Option_Bytes ; Length

		push cs			; Use cs
		pop es			;

		test b cs:fLoadOptions,-1 ;
		call far ptr Pos_Read_File; Write it

		ret			; Done

; Fixed data

sFileName	db "REPLAY.BIN",0

Stk		dw ?			; Stack save

mnu_Main	db cEsc			; ESC
		dw Leave_Main		;

		db "I"			; I
		dw Main_I		;

		db "H"			; H
		dw Main_H		;

		db "K"			; K
		dw Main_K		;

		db "O"			; O
		dw Main_O		;

		db "F"			; *
		dw Main_Write_File	;

		db " "			; Space
		dw Play_A_Game		;

		db 0			; Done

mnu_High	db cEsc			; ESC
		dw Main_Menu		;

		db " "			; Space
		dw Play_A_Game		;

		db 0			; Done

; Strings

sName		db 3,0			; Large
		db 1,00Bh		; Colour

		include title.inc	; Title string

		db 3,1			; Medium

		db 1,00Bh		; Blue

		db 2			; Pos
		dw 130,62		;

		db "( For any PC-AT with VGA )"	;

		db 3,2			; Small

		db 1,009h		; Dark blue

		db 2			; Pos
		dw 10,39		;

		db "( . . stars with Capt. Crayon in ""Suicide Salad"" (c) Design-Design Software . . )"

		db 3,1			; Medium

		db 1,00Ch		;

		db 2
		dw 178,110

		db "(H)"

		db 2
		dw 320,110

		db "Highscores"

		db 1,00Bh

		db 2
		dw 182,140

		db "(I)"

		db 2
		dw 320,140

		db "Information"

		db 1,00Dh

		db 2
		dw 178,170

		db "(K)"

		db 2
		dw 320,170

		db "Change The Keys"

		db 1,00Ah

		db 2
		dw 178,200

		db "(O)"

		db 2
		dw 320,200

		db "Game Options"

		db 1,0Fh

		db 2
		dw 150,230

		db "(SPACE)"

		db 2
		dw 320,230

		db "Play The Game"

		db 1,00Eh

		db 2
		dw 164,270

		db "(ESC)"

		db 2
		dw 320,270

		db "Exit"

		db 3,0

		db 1,0Bh

		db 2
		dw 5,310

		db "(c) 1993 Design-Design Software"	;

		; The version number

		include release.inc

; Keys screen

sKeys		db 3,0			; CS

		db 1,009h		; Colour

		include title.inc	; Title

		;

		db 3,2			; CS

		db 1,0Eh		; Colour

		db 2			; Pos
		dw 0,40			;

		db "To change the keys, first select the function you"
		db " want to change by typing the number"

		db 2			; Pos
		dw 0,57			;

		db "that corresponds to that function, then type the"
		db " key, or keys, that you want to use."

		db 2			; Pos
		dw 0,74			;

		db "Finish by typing the ",1,0Fh,"(ESC)",1,0Eh," key."

		db 2			; Pos
		dw 0,96			;

		db "You can have the same key perform more than one"
		db " function if you wish."

		db 0

; Up

sKeys1		db 2			; Pos
		dw 0,119		;

		db "Press ",1,0Fh,"(ESC)",1,0Eh," when you have finished"
		db " with these keys."

		; Now the keys

		db 3,1			; CS

		db 2			; Poss
		dw 0,142		;

		db 1,0Fh		; Colour

		db "(1)",1,0Eh," - Up"	; 1

		; Down

		db 2			; Poss
		dw 0,184		;

		db 1,0Fh		; Colour

		db "(2)",1,0Eh," - Down"; 1

		; Left

		db 2			; Poss
		dw 0,226		;

		db 1,0Fh		; Colour

		db "(3)",1,0Eh," - Left"; 1

		; Right

		db 2			; Poss
		dw 0,268		;

		db 1,0Fh		; Colour

		db "(4)",1,0Eh," - Right"; 1

		; Fire

		db 2			; Poss
		dw 0,310		;

		db 1,0Fh		; Colour

		db "(5)",1,0Eh," - Fire"; 1

		db 0

; Keys screen 2

; Smart

sKeys2		db 2			; Pos
		dw 0,119		;

		db "Press ",1,0Fh,"(ESC)",1,0Eh," when you have finished"
		db " to return to the menu."

		; Now the keys

		db 3,1			; CS

		db 2			; Poss
		dw 0,184		;

		db 1,0Fh		; Colour

		db "(1)",1,0Eh," - Bomb" ; 1

		;

		db 2			; Poss
		dw 0,226		;

		db 1,0Fh		; Colour

		db "(2)",1,0Eh," - Pause";

		;

		db 2			; Poss
		dw 0,268		;

		db 1,0Fh		; Colour

		db "(3)",1,0Eh," - Boss";

		db 0

; UDK table 1

UDK_List1	db "1"			; Up

		dw Key_Up,140,142	; Pos

		db "2"			; Down

		dw Key_Down,140,184	; Pos

		db "3"			; Left

		dw Key_Left,140,226	; Pos

		db "4"			; Right

		dw Key_Right,140,268	; Pos

		db "5"			; Fire

		dw Key_Fire,140,310	; Pos

		db 0			; End

; UDK table 2

UDK_List2	db "1"			; Smart

		dw Key_Smart,140,184	; Pos

		db "2"			; Pause

		dw Key_Pause,140,226	; Pos

		db "3"			; Boss

		dw Key_Boss,140,268	; Pos

		db 0			; End

; Main info menu

mnu_Info	db cEsc			; ESC
		dw Main_Menu		;

		db "E"			; Essential text
		dw Info_Ess		;

		db "S"			; Story time
		dw Info_Dave		;

		db "I"			; Instructions
		dw Info_Play		;

		db "V"			; Various
		dw Info_Var		;

		db "O"			; Ordering text
		dw Info_Order		;

		db 0			; Done

; Dave's stuff menu

mnu_Dave	db cEsc			; ESC
		dw 1			;

		db " "			; Space
		dw 0			;

		db 0			; Done

; Shareware stuff menu

mnu_Share	db cEsc			; ESC
		dw 0			;

		db " "			; Space
		dw 0			;

		db cCret		; Return
		dw 1			;

		db 0			; Done

sWaiting	db 3,2			; Small
		db 1,009h		; Colour

		db 2			; Pos
		dw 0,330		;

		db "Hang on, human . . ." ; Text

		db 0

; Title line

sTitle		db 3,0			; CS

		db 1,0Bh		; Colour

		include title.inc	; Title

		db 0

sEsc_Or_Space	db 3,0			; CS

		db 1,09h		;

		db 2			; Pos
		dw 0,305		;

		db "ESC for the menu, SPACE to play"

		db 0			; End

; Score line

sScore		db 3,0			; CS

		db 1,00Eh		; Colour

		db 2			; Pos
		dw 90,130		;

		db "You scored  -  "

		db 0			; End

	; Small screen

s_S_Score	db 3,2			; CS

		db 1,00Eh		; Colour

		db 2			; Pos
		dw 250,140		;

		db "You scored  -  "

		db 0			; End

; Title screen header

sTitle_2	db 3,0			; CS

		db 1,00Bh		; Colour

		include title.inc	; Title

		db 3,2			; Small

		db 1,009h		; Dark blue

		db 2			; Pos
		dw 76,39		;

		db "( . . another original game from Design-Design Software . . )"

		db 0			; End

; Info screen

sInfo		db 3,2			; Small

		db 1,009h		; Blue

		db 2			; Pos
		dw 0,331		;

		db "H.M.Gov. Health Warning: Using compilers can seriously impair your"
		db " performance !"

		db 3,1			; Medium

		db 1,00Bh		;

		db 2
		dw 178,110

		db "(E)"

		db 2
		dw 320,110

		db "Essential text - read first !"

		db 1,00Eh

		db 2
		dw 182,140

		db "(I)"

		db 2
		dw 320,140

		db "Instructions"

		db 1,00Dh

		db 2
		dw 177,170

		db "(V)"

		db 2
		dw 320,170

		db "Various bits"

		db 1,00Ch

		db 2
		dw 178,200

		db "(S)"

		db 2
		dw 320,200

		db "Story time"

		db 1,00Bh

		db 2
		dw 178,230

		db "(O)"

		db 2
		dw 320,230

		db "Ordering information"

		db 1,00Eh
		
		db 2
		dw 164,270

		db "(ESC)"

		db 2
		dw 320,270

		db "Exit"

		db 0			; End

; Options screen

sOptions	db 3,1			; Medium

		db 1,00Ch		;

		db 2
		dw 178,110

		db "(N)"

		db 2
		dw 320,110

		db "Noises"

		db 1,00Ch

		db 2
		dw 178,140

		db "(D)"

		db 2
		dw 320,140

		db "Difficulty"

		db 1,00Ch

		db 2
		dw 178,200

		db "(E)"

		db 2
		dw 320,200

		db "Extra Options"

		db 1,0Fh

		db 2
		dw 150,300

		db "(SPACE)"

		db 2
		dw 320,300

		db "Play The Game"

		db 1,00Eh
		
		db 2
		dw 164,330

		db "(ESC)"

		db 2
		dw 320,330

		db "Exit"

		db 0			; End

; Noise options


sNoise_ON	db 1,00Bh		; Colour

		db 2			; Posn
		dw 450,110		;

		db "ON",0		; Str

sNoise_OFF	db 1,003h		;

		db 2			;
		dw 450,110		;

		db "OFF",0		;

sDiff_0		db 1,009h		; Easy

		db 2			;
		dw 450,140		;

		db "Mild"		;

		db 2			;
		dw 320,155		;

		db 3,2			; Small

		db "( When not shooting, you can't be damaged"

		db 2			;
		dw 320,168		;

		db "your score doesn't count, and you can't go"

		db 2			;
		dw 320,181		;

		db "beyond the first few sheets.)",0

sDiff_1		db 1,003h		; Easy

		db 2			;
		dw 450,140		;

		db "Medium"		;

		db 2			;
		dw 320,155		;

		db 3,2			; Small

		db "( Fairly reasonable )",0

sDiff_2		db 1,00Bh		; Easy

		db 2			;
		dw 450,140		;

		db "Hot"		;

		db 2			;
		dw 320,155		;

		db 3,2			; Small

		db "( Faster aliens and projectiles )",0

sDiff_3		db 1,00Fh		; Easy

		db 2			;
		dw 450,140		;

		db "Suicide !"		;

		db 2			;
		dw 320,155		;

		db 3,2			; Small

		db "( Instant death ! )",0

sLang		db 1,00Ch

		db 2
		dw 178,240

		db 3,1			

		db "(L)"

		db 2
		dw 320,240

		db "Language !",0

sLang_0		db 1,00Bh		; Easy

		db 2			;
		dw 450,240		;

		db 3,1			; Medium

		db "Assembler"		;

		db 2			;
		dw 320,265		;

		db 3,2			; Small

		db "( Wheee ! )",0

sLang_1		db 1,00Ah		; Easy

		db 2			;
		dw 450,240		;

		db 3,1			;

		db "C"			;

		db 2			;
		dw 320,265		;

		db 3,2			; Small

		db "( Crap ! )",0

sLang_2		db 1,002h		; Easy

		db 2			;
		dw 450,240		;

		db 3,1			;

		db "C++"		;

		db 2			;
		dw 320,265		;

		db 3,2			; Small

		db "( Crapier ! )",0

sLang_3		db 1,009h		; Easy

		db 2			;
		dw 450,240		;

		db 3,1			;

		db "BASIC"		;

		db 2			;
		dw 320,265		;

		db 3,2			; Small

		db "( Crapiest ! )",0

; Filenames

sKey_File	db "GAMEZONE.KEY",0	; The key file
sOpt_File	db "GAMEZONE.OPT",0	; The options file
sHigh_File	db "GAMEZONE.HGH",0	; The highscores

; Vars

Front_Screen	db 0			; The currently shown screen

Order_F		db 0			; Played tetris

Score		dw 0			; Score

pUDK_List	dw 0			; Ptr to the UDK data

