; Key scanning routines

; Export the interface routines

F_Link_Kbd:	mov al,cs:fForce_AT	; Flag
		call Link_Kbd		; Link it

		retf			; Exit

F_Unlink_Kbd:	call Unlink_Kbd		; Unlink it

		retf			; Exit

; Test a key. NZ = pressed

Test_UDK:	mov bl,cs:[di]		; Get the next key-code

		cmp bl,0		; End ?
		je TUDK_X		; Yes, skip (Z)

		mov bh,0		; -16 bit
		add bx,o Key_Matrix	; Add base

		test b cs:[bx],1	; Pressed ?
		jne TUDK_X		; Yes, skip NZ

		inc di			; Skip to the next key

		jmp s Test_UDK		; Loop

TUDK_X:		ret			; Done

; Save bx

Test_UDK_S:	push bx			; Save
		call Test_UDK		; Test it
		pop bx			; Restore

		retf			; Done, (FAR)

; The key test routines

Test_Left:	mov di,o Key_Left	; Left ?
		jmp s Test_UDK_S	; Drive it

Test_Right:	mov di,o Key_Right	;
		jmp s Test_UDK_S	; Drive it

Test_Up:	mov di,o Key_Up		;
		jmp s Test_UDK_S	; Drive it

Test_Down:	mov di,o Key_Down	;
		jmp s Test_UDK_S	; Drive it

Test_Fire:	mov di,o Key_Fire	;
		jmp s Test_UDK_S	; Drive it

Test_Pause:	mov di,o Key_Pause	;
		jmp s Test_UDK_S	; Drive it

Test_Boss:	mov di,o Key_Boss	;
		jmp s Test_UDK_S	; Drive it

Test_Esc:	mov di,o Key_Esc	;
		jmp s Test_UDK_S	; Drive it

; Editing keys

Test_F1:	mov di,o Key_F1		;
		jmp s Test_UDK_S	;

Test_F2:	mov di,o Key_F2		;
		jmp s Test_UDK_S	;

Test_F3:	mov di,o Key_F3		;
		jmp s Test_UDK_S	;

Test_F4:	mov di,o Key_F4		;
		jmp s Test_UDK_S	;

Test_F5:	mov di,o Key_F5		;
		jmp s Test_UDK_S	;

Test_F6:	mov di,o Key_F6		;
		jmp s Test_UDK_S	;

Test_F7:	mov di,o Key_F7		;
		jmp s Test_UDK_S	;

Test_F8:	mov di,o Key_F8		;
		jmp s Test_UDK_S	;

Test_F9:	mov di,o Key_F9		;
		jmp s Test_UDK_S	;

Test_F10:	mov di,o Key_F10	;
		jmp s Test_UDK_S	;

Test_F11:	mov di,o Key_F11	;
		jmp s Test_UDK_S	;

Test_F12:	mov di,o Key_F12	;
		jmp s Test_UDK_S	;

Test_UA:	mov di,o Key_UA		;
		jmp s Test_UDK_S	;

Test_DA:	mov di,o Key_DA		;
		jmp s Test_UDK_S	;

; The current key data

Key_Up		db kN			; The Up-keyset
		db UDK_nKeys dup (0)	;

Key_Down	db kM			;
		db UDK_nKeys dup (0)	;

Key_Left	db kZ			;
		db UDK_nKeys dup (0)	;

Key_Right	db kX			;
		db UDK_nKeys dup (0)	;

Key_Fire	db kSPACE		;
		db UDK_nKeys dup (0)	;

Key_Smart	db kTAB			;
		db UDK_nKeys dup (0)	;

Key_Pause	db kSCROLL		;
		db UDK_nKeys dup (0)	;

Key_Boss	db kF5,kF6,kF7,kF8	;
		db UDK_nKeys-3 dup (0)	;

Key_Esc		db kEsc,0		; Dummy escape key

; Editing keys

Key_F1		db kF1,0		; F1
Key_F2		db kF2,0		; F2
Key_F3		db kF3,0		; F3
Key_F4		db kF4,0		; F4
Key_F5		db kF5,0		; F5
Key_F6		db kF6,0		; F6
Key_F7		db kF7,0		; F7
Key_F8		db kF8,0		; F8
Key_F9		db kF9,0		; F9
Key_F10		db kF10,0		; F10
Key_F11		db kF11,0		; F11
Key_F12		db kF12,0		; F12

Key_UA		db kUA,0		;
Key_DA		db kDA,0		;

; Vars
